# -*- coding: utf-8 -*-
from setuphelpers import *
import ctypes


def install():
    with enable_file_system_redirection():
        test = WAPT.install("insat-lenovo-system-update")
        print(test)


def install():
    with disable_file_system_redirection():
        cacert32_path = "C:\\windows\\SysWOW64\\config\\systemprofile\\AppData\\Local\\.certifi\\cacert.pem"
        cacert64_path = "C:\\windows\\system32\\config\\systemprofile\\AppData\\Local\\.certifi\\cacert.pem"
        ensure_dir(cacert64_path)
        filecopyto(cacert32_path, cacert64_path)

        test = WAPT.install("insat-lenovo-system-update")
        print(test)


class enable_file_system_redirection(object):
    r"""Context manager to enable temporarily the wow3264 file redirector

    >>> with enable_file_system_redirection():
    ...     winshell.get_path(shellcon.CSIDL_PROGRAM_FILES)
    u'C:\\Program Files (x86)'
    """
    if iswin64():
        _enable = ctypes.windll.kernel32.Wow64EnableWow64FsRedirection
        _revert = ctypes.windll.kernel32.Wow64RevertWow64FsRedirection
    else:
        _enable = None
        _revert = None

    def __enter__(self):
        if self._enable:
            self.old_value = ctypes.c_long()
            self.success = self._enable(ctypes.byref(self.old_value))

    def __exit__(self, type, value, traceback):
        if self._revert and self.success:
            self._revert(self.old_value)
